{ 2005-02-19 programmeerimisvistlus                                        }
{ lesanne: HULKNURK                                                        }
{ Autor: Indrek Jentson                                                     }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'enurk.sis';
   valf = 'enurk.val';
   maxN = 1000;

type
   Tipp = record
      jnr : integer;
      x, y : integer;
   end;

var
   Cx, Cy : integer;
   minX, maxX, minY, maxY : integer;
   N : integer;
   M : array[1..maxN] of Tipp;

function ReadData : boolean;
var i : integer;
    f : Text;
begin
   minX := 20000; maxX := -20000;
   minY := 20000; maxY := -20000;
{$I-}
   assign(f, sisf); reset(f);
{$I+}
   if IOResult = 0 then
   begin
      readln(f, N);
      for i := 1 to N do begin
         M[i].jnr := i;
         readln(f, M[i].x, M[i].y);
         { Paisutame koordinaatide vrtuseid nii, et saaksime 
           keskpunkti igal juhul punktide vahele paigutada }
         M[i].x := M[i].x * 2;
         M[i].y := M[i].y * 2;
         { Leiame koordinaatide miinimum- ja maksimumvrtused }
         if M[i].x > maxX then maxX := M[i].x;
         if M[i].x < minX then minX := M[i].x;
         if M[i].y > maxY then maxY := M[i].y;
         if M[i].y < minY then minY := M[i].y;
      end;
      close(f);
      { Leiame keskpunkti koordinaadid }
      Cx := (minX + maxX) div 2;
      Cy := (minY + maxY) div 2;
      { Tagame, et see ei langeks kokku mne punkti koordinaatidega }
      Cx := Cx div 2 * 2 + 1;
      Cy := Cy div 2 * 2 + 1;
      ReadData := true;
   end
   else
      ReadData := false;
end;

function isGreater(P1, P2 : Tipp) : boolean;
var
   v1y, v1x, v2y, v2x, vk : LongInt;
begin
   { Leiame vektorid }
   v1y := P1.y - Cy; v1x := P1.x - Cx;
   v2y := P2.y - Cy; v2x := P2.x - Cx;
   if (v1y >= 0) and (v2y < 0) then { eri pooltele suunatud }
      isGreater := true
   else if (v1y < 0) and (v2y >= 0) then
      isGreater := false
   else if (v1y = 0) and (v2y = 0) then { mlemad x-teljel }
      begin
      if (v1x > 0) and (v2x < 0) then
        isGreater := false
      else if (v1x < 0) and (v2x > 0) then
        isGreater := true
      else
        isGreater := abs(v1x) > abs(v2x)
      end
   else
     begin
     { Leiame vektorkorrutise }
     vk := v1x * v2y - v2x * v1y;
     if vk > 0 then
        isGreater := false
     else if vk < 0 then
        isGreater := true
     else { samas suunas } 
        isGreater := (v1x*v1x + v1y*v1y) > (v2x*v2x + v2y*v2y)
     end
end;

procedure FindSolution;
var
  i, j : Integer;
  V    : Tipp;
begin
  { Jrjestame "polaarkoordinaatide" jrgi }
  for i := 1 to N-1 do
     for j := i+1 to N do
        if isGreater(M[i], M[j]) then
        begin
           V    := M[j];
           M[j] := M[i];
           M[i] := V;
        end;
end;

procedure WriteAnswer;
var j : integer;
    f : Text;
begin
   assign(f, valf); rewrite(f);
   for j := 1 to N do begin
      if j > 1 then write(f, ' ');
      write(f, M[j].jnr);
   end;
   close(f);
end;

begin
  if ReadData then
    begin
    FindSolution;
    WriteAnswer;
    end;
end.
