const
   maxn = 10;
   maxm = 10;
   eisaa = 'EI SAA';
type
   aine = record                                          { ppeaine andmed }
      s : string;                                            { aine nimetus }
      p : integer;                        { ppimiseks vajalike pevade arv }
      m : integer;                                      { eksamipevade arv }
      a : array [1..maxm] of integer;                        { eksamipevad }
      t : boolean;                               { kas eksam on juba tehtud }
   end;
var
   n : integer;
   a : array [1..maxn] of aine;
   ok : boolean;

{$I+}
procedure loe_sisend;
var f : text; i, j : integer;
begin
   assign(f, paramstr(1)); reset(f);
   readln(f, n);
   for i := 1 to n do begin
      readln(f, a[i].s);
      readln(f, a[i].p);
      read(f, a[i].m);
      for j := 1 to a[i].m do
         read(f, a[i].a[j]);
      readln(f);
      a[i].t := false;
   end;
   close(f);
end;

{$I+}
procedure loe_vastus;
var f : text; s : string;
begin
   assign(f, paramstr(2)); reset(f);
   readln(f, s);
   ok := (s <> eisaa);
   close(f);
end;

function leia_aine(s : string) : integer;
var i : integer;
begin
   for i := 1 to n do
      if a[i].s = s then
         exit(i);
   exit(-1);
end;

function leia_eksam(k, p : integer) : boolean;
var i : integer;
begin
   for i := 1 to a[k].m do
      if a[k].a[i] = p then
         exit(true);
   exit(false);
end;

{$I-}
procedure loe_valjund;
var f : text; i, k, p, e : integer; s : string;
begin
   assign(f, paramstr(3)); reset(f);
   if ioresult > 0 then begin
      writeln('Viga faili ', paramstr(3), ' avamisel');
      halt(1);
   end;
   if ok then begin
      e := 1; { eelmine eksam oleks nagu olnud 1. jaanuaril }
      for i := 1 to n do begin
         readln(f, s);
         if ioresult > 0 then begin
            writeln('Viga faili ', paramstr(3), ' lugemisel');
            halt(1);
         end;
         k := leia_aine(s);
         if k < 0 then begin
            writeln('Tundmatu aine ', s);
            halt(1);
         end;
         if a[k].t then begin
            writeln('Korduv eksam aines ', a[k].s);
            halt(1);
         end;
         read(f, p);
         if ioresult > 0 then begin
            writeln('Viga faili ', paramstr(3), ' lugemisel');
            halt(1);
         end;
         if not seekeoln(f) then
            writeln('Liigsed smbolid ', 2 * i + 1, '. rea lpus');
         readln(f);
         if not leia_eksam(k, p) then begin
            writeln('Tundmatu eksamipev ', p, ' aines ', a[k].s);
            halt(1);
         end;
         if p <= e + a[k].p then begin
            writeln('Ebapiisav ppimise aeg aines ', a[k].s);
            halt(1);
         end;
         a[k].t := true;
         e := p;
      end;
   end else begin { not ok }
      readln(f, s);
      if ioresult > 0 then begin
         writeln('Viga faili ', paramstr(3), ' lugemisel');
         halt(1);
      end;
      if s <> eisaa then begin
         writeln('Vale vastus ', s, ', peaks olema ', eisaa);
         halt(1);
      end;
   end; { ok / not ok }
   if not seekeof(f) then
      writeln('Liigsed smbolid faili lpus');
   close(f);
end;

procedure kontrolli_tulemus;
var i : integer;
begin
   if ok then
      for i := 1 to n do
         if not a[i].t then begin
            { seda ei peaks juhtuda saama! }
            writeln('Tegemate eksam aines ', a[i].s);
            halt(1);
         end;
end;

begin
   if paramcount <> 3 then begin
      writeln('Kasutamine: ', paramstr(0), ' sisendfail nidisfail vljundfail');
      halt(1);
   end;
   loe_sisend;
   loe_vastus;
   loe_valjund;
   kontrolli_tulemus;
   writeln('Korras');
end.
