{ 2005-02-19 programmeerimisvistlus                                        }
{ lesanne: TLKIMINE                                                       }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'atolk.sis';
   valf = 'atolk.val';
   max = 10000;                              { snastiku maksimaalne suurus }

var
   n : integer;                                          { snastiku suurus }
   a, b : array [1..max] of string;                { tlked on a[i] -> b[i] }

{ lisab snastikku uue snapaari }
procedure lisa(var s : string; i : integer);
var p : integer;
begin
   p := pos('->', s);
   a[i] := copy(s, 1, p - 1);
   b[i] := copy(s, p + 2, length(s) - p - 1);
end;

{ kahendotsing snastikus }
function otsi(var s : string) : integer;
var i1, i2, k : integer;
begin
   i1 := 1; i2 := n;
   while i1 < i2 do begin
      k := (i1 + i2) div 2;
      if a[k] < s then
         i1 := k + 1
      else
         i2 := k;
   end;
   if a[i1] = s then
      otsi := i1
   else
      otsi := 0;
end;

var
   fsis, fval : text;
   i : integer;
   s : string;
   c : char;
begin
   assign(fsis, sisf); reset(fsis);
   assign(fval, valf); rewrite(fval);

   { loeme snastiku }
   readln(fsis, n);
   for i := 1 to n do begin
      readln(fsis, s);
      lisa(s, i);
   end;

   { loeme ja ttleme teksti }
   readln(fsis);                                { jtame vahele ridade arvu }
   s := '';                                          { jooksev sna on thi }
   while not eof(fsis) do begin
      read(fsis, c);
      if c in ['a'..'z'] then                                 { kui on tht }
         s := s + c                                   { siis lisame snasse }
      else begin
         if length(s) > 0 then begin                         { kui oli sna }
            i := otsi(s);                              { otsime snastikust }
            if i > 0 then                              { kui oli snastikus }
               write(fval, b[i])                    { vljastame tlkevaste }
            else                                                    { muidu }
               write(fval, s);                       { vljastame sna enda }
         end;
         s := '';                                   { nd enam sna ei ole }
         write(fval, c);                             { vljastame mittethe }
      end;
   end;
   if length(s) > 0 then begin                   { kui faili lpus oli sna }
      i := otsi(s);                                    { otsime snastikust }
      if i > 0 then                                    { kui oli snastikus }
         write(fval, b[i])                          { vljastame tlkevaste }
      else                                                          { muidu }
         write(fval, s);                             { vljastame sna enda }
   end;

   close(fval);
   close(fsis);
end.
