const
   max = 1000;
var
   n : integer;
   x, y : array [1..max] of integer;
   a : array [1..max] of integer;

{$I+}
procedure loe_sisend;
var f : text; i : integer;
begin
   assign(f, paramstr(1)); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, x[i], y[i]);
   close(f);
end;

{$I-}
procedure loe_valjund;
var f : text; i : integer;
begin
   assign(f, paramstr(2)); reset(f);
   if ioresult > 0 then begin
      writeln('Viga faili ', paramstr(2), ' avamisel');
      halt(1);
   end;
   for i := 1 to n do begin
      if seekeof(f) then begin
         writeln('Enneaegne faili lpp');
         halt(1);
      end;
      read(f, a[i]);
      if ioresult > 0 then begin
         writeln('Viga faili lugemisel');
         halt(1);
      end;
      if (a[i] < 1) or (a[i] > n) then begin
         writeln('Lubamatu punkti number ', a[i]);
         halt(1);
      end;
   end;
   if not seekeof(f) then
      writeln('Liigsed smbolid faili lpus');
   close(f);
end;

{ kas punkt a[i] asub ligul a[j1]-a[j2]? }
function loigul(i, j1, j2 : integer) : boolean;
var x1, y1 : longint; { vektori a[i]->a[j1] koordinaadid }
var x2, y2 : longint; { vektori a[i]->a[j2] koordinaadid }
begin
   x1 := x[a[j1]] - x[a[i]]; y1 := y[a[j1]] - y[a[i]];
   x2 := x[a[j2]] - x[a[i]]; y2 := y[a[j2]] - y[a[i]];
   if x1 * y2 - x2 * y1 = 0 then { a[i] on a[j1] ja a[j2] mratud sirgel }
      if x1 * x2 + y1 * y2 <= 0 then { a[i] on sirgel a[j1] ja a[j2] vahel }
         exit(true);
   exit(false);
end;

{ kas a[j1] ja a[j2] asuvad teine teisel pool sirget a[i1]-a[i2]? }
function vahel(i1, i2, j1, j2 : integer) : boolean;
var xx, yy : longint; { vektori a[i1]->a[i2] koordinaadid }
var x1, y1 : longint; { vektori a[i1]->a[j1] koordinaadid }
var x2, y2 : longint; { vektori a[i1]->a[j2] koordinaadid }
var vk1, vk2 : int64; { vektorkorrutised }
begin
   x1 := x[a[j1]] - x[a[i1]]; y1 := y[a[j1]] - y[a[i1]];
   xx := x[a[i2]] - x[a[i1]]; yy := y[a[i2]] - y[a[i1]];
   x2 := x[a[j2]] - x[a[i1]]; y2 := y[a[j2]] - y[a[i1]];
   vk1 := x1 * yy - y1 * xx; vk2 := x2 * yy - y2 * xx;
   exit(vk1 * vk2 <= 0); { ega vektorkorrutised ole samamrgilised? }
end;

{ kas ligud a[i1]-a[i2] ja a[j1]-a[j2] likuvad? }
function loikuvad(i1, i2, j1, j2 : integer) : boolean;
var xi, yi : longint; { vektori a[i1]->a[i2] koordinaadid }
var xj, yj : longint; { vektori a[j1]->a[j2] koordinaadid }
begin
   if i2 = j1 then
      exit(loigul(i1, j1, j2) or loigul(j2, i1, i2));
   if i1 = j2 then
      exit(loigul(i2, j1, j2) or loigul(j1, i1, i2));
   xi := x[a[i2]] - x[a[i1]]; yi := y[a[i2]] - y[a[i1]];
   xj := x[a[j2]] - x[a[j1]]; yj := y[a[j2]] - y[a[j1]];
   if xi * yj - xj * yi = 0 then { sirged on paralleelesed }
      exit(loigul(i1, j1, j2) or loigul(i2, j1, j2) or loigul(j1, i1, i2) or loigul(j2, i1, i2))
   else { sirged ei ole paralleelsed }
      exit(vahel(i1, i2, j1, j2) and vahel(j1, j2, i1, i2));
end;

procedure kontrolli_vastus;
var i, j : integer;
begin
   for i := 1 to n - 1 do
      for j := i + 1 to n do
         if a[i] = a[j] then begin
            writeln('Korduvalt lbitud punkt ', a[i]);
            halt(1);
         end;
   for i := 1 to n - 1 do
      for j := i + 1 to n do
         if loikuvad(i, i + 1, j, j mod n + 1) then begin
            writeln('Ligud ', a[i], '-', a[i + 1], ' ja ', a[j], '-', a[j mod n + 1], ' likuvad');
            halt(1);
         end;
end;

begin
   if paramcount <> 2 then begin
      writeln('Kasutamine: ', paramstr(0), ' sisendfail vljundfail');
      halt(1);
   end;
   loe_sisend;
   loe_valjund;
   kontrolli_vastus;
   writeln('Korras');
end.
