const
   max = 100;
   eisaa = 'EI SAA';
var
   n, m : integer;
   a, b : array [0..max+1, 0..max+1] of integer;
   ok : boolean;

{$I+}
procedure loe_sisend;
var f : text; i, j : integer;
begin
   assign(f, paramstr(1)); reset(f);
   readln(f, n, m);
   for i := 1 to n do
      for j := 1 to m do
         read(f, a[i, j]);
   close(f);
end;

{$I+}
procedure loe_vastus;
var f : text; s : string;
begin
   assign(f, paramstr(2)); reset(f);
   readln(f, s);
   ok := (s <> eisaa);
   close(f);
end;

{$I-}
procedure loe_valjund;
var f : text; k, i, r, v : integer; s : string;
begin
   assign(f, paramstr(3)); reset(f);
   if ioresult > 0 then begin
      writeln('Viga faili ', paramstr(3), ' avamisel');
      halt(1);
   end;
   readln(f, s);
   if ioresult > 0 then begin
      writeln('Viga faili ', paramstr(3), ' lugemisel');
      halt(1);
   end;
   if ok then begin
      val(s, k, i);
      if i <> 0 then begin
         writeln('Lubamatu kikude arv ', s);
         halt(1);
      end;
      if k <> n * m then
         writeln('Vale kikude arv ', k, ', peaks olema ', n * m);
      for i := 1 to k do begin
         read(f, r, v);
         if ioresult > 0 then begin
            writeln('Viga faili ', paramstr(3), ' lugemisel');
            halt(1);
         end;
         if not seekeoln(f) then
            writeln('Liigsed smbolid ', i + 1, '. rea lpus');
         readln(f);
         if (r < 1) or (r > n) or (v < 1) or (v > m) then begin
            writeln('Lubamatu kik ', r, ' ', v);
            halt(1);
         end;
         if b[r, v] > 0 then begin
            writeln('Korduv kik ', r, ' ', v);
            halt(1);
         end;
         b[r, v] := 1;
         if b[r - 1, v] > 0 then b[r - 1, v] := b[r - 1, v] + 1;
         if b[r + 1, v] > 0 then b[r + 1, v] := b[r + 1, v] + 1;
         if b[r, v - 1] > 0 then b[r, v - 1] := b[r, v - 1] + 1;
         if b[r, v + 1] > 0 then b[r, v + 1] := b[r, v + 1] + 1;
      end;
   end else begin { not ok }
      if s <> eisaa then begin
         writeln('Vale vastus ', s, ', peaks olema ', eisaa);
         halt(1);
      end;
   end; { ok / not ok }
   if not seekeof(f) then
      writeln('Liigsed smbolid faili lpus');
   close(f);
end;

procedure kontrolli_tulemus;
var i, j : integer;
begin
   if ok then
      for i := 1 to n do
         for j := 1 to n do
            if a[i, j] <> b[i, j] then begin
               writeln('Vale vrtus ', b[i, j], ' positsioonis ', i, ' ', j, ', peaks olema ', a[i, j]);
               halt(1);
            end;
end;

begin
   if paramcount <> 3 then begin
      writeln('Kasutamine: ', paramstr(0), ' sisendfail nidisfail vljundfail');
      halt(1);
   end;
   loe_sisend;
   loe_vastus;
   loe_valjund;
   kontrolli_tulemus;
   writeln('Korras');
end.
